// -*- c++ -*-
//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Fri May 31 11:39:45 2013 by ROOT version 5.34/05
// from TTree Zprime_Py8/Zprime to ttbar ROOT tree
// found on file: signal_Zprime.root
//////////////////////////////////////////////////////////

#ifndef Zprime_Py8_h
#define Zprime_Py8_h

#include "Selectors.h"
#include "Event.h"

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <TH1D.h>

#include <string>
#include <cstdio>

// Header file for the classes stored in the TTree if any.

// Fixed size dimensions of array or collections stored in the TTree if any.

class Zprime_Py8 {
public :
  TChain         *fChain;   //!pointer to the analyzed TTree or TChain
  Int_t           fCurrent; //!current Tree number in a TChain

   // Declaration of leaf types
  Int_t           Nentry;
  Int_t           Npartons;
  Int_t           Nparticles;
  Int_t           ID[100000];   //[Nentry]
  Int_t           Stat[100000];   //[Nentry]
  Double_t        Charge[100000];   //[Nentry]
  Double_t        Px[100000];   //[Nentry]
  Double_t        Py[100000];   //[Nentry]
  Double_t        Pz[100000];   //[Nentry]
  Double_t        P0[100000];   //[Nentry]
  Double_t        Pm[100000];   //[Nentry]
  Double_t        Pt[100000];   //[Nentry]
  Double_t        Rap[100000];   //[Nentry]
  Double_t        Phi[100000];   //[Nentry]
  Double_t        Eta[100000];   //[Nentry]

  // List of branches
  TBranch        *b_Nentry;   //!
  TBranch        *b_Npartons;   //!
  TBranch        *b_Nparticles;   //!
  TBranch        *b_ID;   //!
  TBranch        *b_Stat;   //!
  TBranch        *b_Charge;   //!
  TBranch        *b_Px;   //!
  TBranch        *b_Py;   //!
  TBranch        *b_Pz;   //!
  TBranch        *b_P0;   //!
  TBranch        *b_Pm;   //!
  TBranch        *b_Pt;   //!
  TBranch        *b_Rap;   //!
  TBranch        *b_Phi;   //!
  TBranch        *b_Eta;   //!

  Zprime_Py8(TChain *chain=0);
  virtual ~Zprime_Py8();
  virtual Int_t    Cut(Long64_t entry);
  virtual Int_t    GetEntry(Long64_t entry);
  virtual Long64_t LoadTree(Long64_t entry);
  virtual void     Init(TChain *chain);
  virtual void     Loop(Long64_t nevts=-1,const std::string& outName="");
  template<class T>
  void             Loop(T& pileupServer,Int_t mu,Long64_t nevts=-1,
			const std::string& outName="",
			const std::string& pupName="");
  virtual Bool_t   Notify();
  virtual void     Show(Long64_t entry = -1);

public:

  bool book();
  bool write(const std::string& outName="");
  bool analyze(Event& pEvt);
  //  bool ticker(Long64_t nVtx,Long64_t nfreq,Long64_t nevts);

  template<class H>
  void writeHist(H* pHist);

private:

  int _evtCtr;
  int _evtFreq;

  TH1D* h_nsigparts;
  TH1D* h_etasigparts;
  TH1D* h_ptsigparts;

  TH1D* h_nallparts;
  TH1D* h_etaallparts;
  TH1D* h_ptallparts;

  TH1D* h_npupparts;
  TH1D* h_etapupparts;
  TH1D* h_ptpupparts;
};

#include "Zprime_Py8.icc"

#endif

// #ifdef Zprime_Py8_cxx
// Zprime_Py8::Zprime_Py8(TChain *chain) 
//   : fChain(0)
//   , h_nsigparts(0)
//   , h_etasigparts(0)
//   , h_ptsigparts(0)
//   , h_nallparts(0)
//   , h_etaallparts(0)
//   , h_ptallparts(0)
//   , h_npupparts(0)
//   , h_etapupparts(0)
//   , h_ptpupparts(0)
// {
// // if parameter tree is not specified (or zero), connect the file
// // used to generate this class and read the Tree.
//    if (chain == 0) {
//       TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("signal_Zprime.root");
//       if (!f || !f->IsOpen()) {
//          f = new TFile("signal_Zprime.root");
//       }
//       f->GetObject("Zprime_Py8",chain);

//    }
//    Init(chain);
// }

// Zprime_Py8::~Zprime_Py8()
// {
//    if (!fChain) return;
//    delete fChain->GetCurrentFile();
// }

// Int_t Zprime_Py8::GetEntry(Long64_t entry)
// {
// // Read contents of entry.
//    if (!fChain) return 0;
//    return fChain->GetEntry(entry);
// }
// Long64_t Zprime_Py8::LoadTree(Long64_t entry)
// {
// // Set the environment to read one entry
//    if (!fChain) return -5;
//    Long64_t centry = fChain->LoadTree(entry);
//    if (centry < 0) return centry;
//    if (fChain->GetTreeNumber() != fCurrent) {
//       fCurrent = fChain->GetTreeNumber();
//       Notify();
//    }
//    return centry;
// }

// void Zprime_Py8::Init(TChain *chain)
// {
//    // The Init() function is called when the selector needs to initialize
//    // a new tree or chain. Typically here the branch addresses and branch
//    // pointers of the tree will be set.
//    // It is normally not necessary to make changes to the generated
//    // code, but the routine can be extended by the user if needed.
//    // Init() will be called many times when running on PROOF
//    // (once per file to be processed).

//    // Set branch addresses and branch pointers
//    if (!chain) return;
//    fChain = chain;
//    fCurrent = -1;
//    fChain->SetMakeClass(1);

//    fChain->SetBranchAddress("Nentry", &Nentry, &b_Nentry);
//    fChain->SetBranchAddress("Npartons", &Npartons, &b_Npartons);
//    fChain->SetBranchAddress("Nparticles", &Nparticles, &b_Nparticles);
//    fChain->SetBranchAddress("ID", ID, &b_ID);
//    fChain->SetBranchAddress("Stat", Stat, &b_Stat);
//    fChain->SetBranchAddress("Charge", Charge, &b_Charge);
//    fChain->SetBranchAddress("Px", Px, &b_Px);
//    fChain->SetBranchAddress("Py", Py, &b_Py);
//    fChain->SetBranchAddress("Pz", Pz, &b_Pz);
//    fChain->SetBranchAddress("P0", P0, &b_P0);
//    fChain->SetBranchAddress("Pm", Pm, &b_Pm);
//    fChain->SetBranchAddress("Pt", Pt, &b_Pt);
//    fChain->SetBranchAddress("Rap", Rap, &b_Rap);
//    fChain->SetBranchAddress("Phi", Phi, &b_Phi);
//    fChain->SetBranchAddress("Eta", Eta, &b_Eta);
//    Notify();
// }

// Bool_t Zprime_Py8::Notify()
// {
//    // The Notify() function is called when a new file is opened. This
//    // can be either for a new TTree in a TChain or when when a new TTree
//    // is started when using PROOF. It is normally not necessary to make changes
//    // to the generated code, but the routine can be extended by the
//    // user if needed. The return value is currently not used.

//    return kTRUE;
// }

// void Zprime_Py8::Show(Long64_t entry)
// {
// // Print contents of entry.
// // If entry is not specified, print current entry
//    if (!fChain) return;
//    fChain->Show(entry);
// }
// Int_t Zprime_Py8::Cut(Long64_t entry)
// {
// // This function may be called from Loop.
// // returns  1 if entry is accepted.
// // returns -1 otherwise.
//    return 1;
// }
// #endif // #ifdef Zprime_Py8_cxx
